module MembersReportHelper

  def graph_lines(id, labels, titles, values, options = {})
    width = options[:width] || 800
    height = options[:height] || 400
    max_lines = options[:max_lines] || 20
    max_values = options[:max_values] || 15
    plain_values = []
    i = 0
    values.each do |value|
      if i < max_lines
        plain_values += ((value.size > max_values) ? value[-max_values, max_values] : value)
      end
      i += 1
    end
    url = url_for(:controller => "members_report",
                  :action => "graph_lines",
                  :id => id,
                  :l => labels[0, max_lines],
                  :t => ((titles.size > max_values) ? titles[-max_values, max_values] : titles),
                  :v => plain_values,
                  :s => "#{width}x#{height}")
    tag("embed",
        :type => "image/png",
        :src => url,
        :witdh => width,
        :height => height)
  end

  def render_bugs(bugs)
    text = ""
    if bugs.count > 0
      bugs_links = []
      bugs_hours = 0.0
      bugs.each do |bug|
        bugs_links << "#{link_to_issue(bug)} (#{"%.2f" % bug.total_hours}h)"
        bugs_hours += bug.total_hours
      end
      text += "<br />\n"
      text += "<span class=\"bug_tooltip tracker_bug\">\n"
      text += "  x#{bugs.count} #{"%.2f" % bugs_hours}h\n"
      text += "  <span class=\"bug_tip\">\n"
      text += "    #{l(:label_bugs_caused)}:\n"
      text += "    <ul class=\"bug_list\">\n"
      text += "      <li>#{bugs_links.join("</li>\n      <li>")}</li>\n"
      text += "    </ul>\n"
      text += "  </span>\n"
      text += "</span>\n"
    end
    text
  end

end
