# This plugin should be reloaded in development mode.
if RAILS_ENV == "development"
  ActiveSupport::Dependencies.load_once_paths.reject!{|x| x =~ /^#{Regexp.escape(File.dirname(__FILE__))}/}
end

require "redmine"
require "rubygems"
require "dispatcher"
Dispatcher.to_prepare do 
  begin
    require_dependency "application"
  rescue LoadError
    require_dependency "application_controller"
  end
  Issue.send(:include, MembersReport::IssuePatch)
end
require_dependency "members_report/view_hooks"

RAILS_DEFAULT_LOGGER.info "Members report"

Redmine::Plugin.register :members_report do
  name "Members report plugin"
  url "https://ociotec.com/redmine/projects/members-report"
  author "Emilio González Montaña"
  author_url "http://ociotec.com"
  description "This is a plugin for Redmine reports statistics about members of a project."
  version "0.3.0"
  requires_redmine :version_or_higher => "1.0.2"
  requires_redmine_plugin :advanced_roadmap, :version_or_higher => "0.4.0"
  permission :members_report_me,
             {:members_report => [:me, :graph_lines]}
  permission :members_report_all,
             {:members_report => [:all, :graph_lines]}
  settings :default => {"bug_tracker_ids" => ""},
           :partial => "settings/members_report_settings"
end
