require_dependency "issue"

module MembersReport
  module IssuePatch
    def self.included(base)
      base.class_eval do
  
        def speed
          if @speed.nil?
            if respond_to?("rest_hours") and
               !estimated_hours.nil? and estimated_hours > 0.0 and
               !spent_hours.nil? and !rest_hours.nil? and (spent_hours + rest_hours) > 0.0
              @speed = estimated_hours / (spent_hours + rest_hours)
            else
              @speed = 1.0
            end
          end
          @speed
        end

        def total_hours
          if @total_hours.nil?
            if spent_hours.nil? or spent_hours <= 0.0
              if estimated_hours.nil?
                @total_hours = 0.0
              else
                @total_hours = estimated_hours
              end
            else
              @total_hours = spent_hours + rest_hours
            end
          end
          @total_hours
        end

        def bugs
          if @bugs.nil?
            @bugs = []
            bug_tracker_ids = (Setting.plugin_members_report["bug_tracker_ids"] || []).collect{|id| id.to_i}
            if !bug_tracker_ids.include?(tracker.id)
              relations.each do |relation|
                related_issue = relation.other_issue(self)
                if bug_tracker_ids.include?(related_issue.tracker.id) and !bugs.include?(related_issue)
                  @bugs << related_issue
                end
              end
            end
          end
          @bugs
        end

        def bugs_hours
          if @bugs_hours.nil?
            @bugs_hours = 0.0
            bugs.each do |bug|
              @bugs_hours += bug.total_hours
            end
          end
          @bugs_hours
        end

      end
    end
  end
end
